C By default, the mass loop corrections are calculated by SuSpect  
C   To use another package   change 'define' setting below and
C   set path to the correponding package via lib/Makefile

#define  EwsbMSSM   suspectEwsbMSSM
C#define  EwsbMSSM   isajetEwsbMSSM
C#define  EwsbMSSM   sphenoEwsbMSSM 
C#define  EwsbMSSM   softSusyEwsbMSSM 

      implicit none
C! declaration of external functions
#include "../sources/micromegas.fh"
#include "lib/pmodel.fh"
*      external iargc
*      integer iargc
C! local parameters 
      integer   fast/1/ 
      real*8 Beps/1.E-6/, cut/0.01/
      real*8 Omega,Xf,omg
      character*20 mess
      character*50 argv 
      integer i,err, argc  


C   to save the SLHA  input/output file  uncomment  
C*      call delFiles(0) 
      argc=iargc()
      if(argc.eq.0) then
         write(*,*)' The program needs arguments,'
         write(*,*)' names of files which contain MSSM parameters'
         stop
      endif 

      do i=1,argc
 
         call getarg(i,argv) 
         write(*,*) 'Initial file=',argv
        
         err=readVar(argv)
             
         if(err.eq.-1) then
            write(*,*) 'Can not open the file'
            stop
         endif   
         if(err.gt.0) then
           write(*,*)'Wrong file contents at line ',err
           stop
         endif
   
         err= EwsbMSSM()
         if(err<0) then 
             write(*,*) 'Problem with spectorum calculation'
             goto 13 
         endif

         err=sortOddParticles(mess)
         if(err.ne.0) then
           write(*,*) 'Can not calculate ',mess
        else 
           call HiggsMasses(6)     
           call printMasses(6,1)
       
           if(mess.ne.'~o1') then 
             write(*,*) '~o1 is not LSP'
           else 
             call o1Contents(6)     
   
             Omega=darkOmega(Xf,fast,Beps)
             write(*,fmt='(A3,F6.2,A7,1PE10.2)')
     >'Xf=',Xf,' Omega=',Omega
             omg=printChannels(Xf,cut,Beps,1,6)

             write(*,fmt='(A,3x, 1PE8.2)') 'deltarho=', deltarho()
             write(*,fmt='(A,3x, 1PE8.2)') 'gmuon='    , gmuon()
             write(*,fmt='(A,3x, 1PE8.2)') 'bsgnlo='   , bsgnlo()
             write(*,fmt='(A,3x, 1PE8.2)') 'bsmumu='   , bsmumu()
             if(MassLimits().eq.0)  write(*,*) 'MassLimits OK'

           endif
         endif
13    continue
      enddo 
      end 
