C      === default SUGRA package is SuSpect === 
C  To use another package  change 'define' setting below  and 
C  set path to the correponding package via lib/Makefile    

#define   SUGRA   suspectSUGRA
C#define  SUGRA   isajetSUGRA  
C#define  SUGRA   softSusySUGRA 
C#define  SUGRA   sphenoSUGRA   

      implicit none 
C! external functions 
#include "../sources/micromegas.fh"
#include "lib/pmodel.fh"
c      external iargc,system
c      integer iargc,system
C! local parameters
      integer outP
      real*8  M,Emin,Ntot,Etot,sigmaV,v/0.001/,tab(250),fi
      character*20 mess
      character*100 buff
      character*6 outName(6)/'gamma','e+','p-','nu_e','nu_mu','nu_tau'/
      REAL*8  m0,mhf,a0,tb,sgn
C Variables      
      INTEGER err
      REAL*8  gMG1,gMG2,gMG3,gAl,gAt,gAb,gMHu,gMHd,
     > gMl2,gMl3,gMr2,gMr3,gMq2,gMq3,gMu2,gMu3,gMd2,gMd3
      INTEGER  narg 
      character *100 argv
      REAL*8 val

      narg = iargc()
      if(narg.lt.4) then
        write(*,*) ' One has to launch this program with parameters.'
        write(*,*) ' Four of them are obligatory:'
        write(*,*) '    m0      common scalar mass at GUT scale'
        write(*,*) '    mhf     common gaugino mass at GUT scale'
        write(*,*) '    a0      trilinear soft breaking at GUT scale'
        write(*,*) '    tb      tan(beta)'
        write(*,*) ' Auxiliary parameters are'
        write(*,*) '    sgn  1(default)/-1, sign of Higgsino mass term'
        write(*,*) '    Mtp     top quark pole mass'
        write(*,*) '    MbMb    Mb(Mb) scale independent b-quark mass'
        write(*,*) '    alfSMZ  strong coupling at MZ'
        write(*,*) ' ================================================'
        STOP
      else
        call getarg(1, argv)
        read(argv,*,ERR=100) m0
        call getarg(2, argv)
        read(argv,*,ERR=100) mhf
        call getarg(3, argv)
        read(argv,*,ERR=100) a0
        call getarg(4, argv)
        read(argv,*,ERR=100) tb

        if(narg.ge.5) then
          call getarg(5, argv)
          read(argv,*,ERR=100) sgn
        else 
          sgn=1
        endif 
        if(narg.ge.6) then
          call getarg(6, argv)
          read(argv,*,ERR=100) val
          call assignValW('Mtp',val) 
        endif 
        if(narg.ge.7) then
          call getarg(7, argv)
          read(argv,*,ERR=100) val
          call assignValW('MbMb',val)
        endif 
        if(narg.ge.8) then
          call getarg(8, argv)
          read(argv,*,ERR=100) val
          call assignValW('alfSMZ',val)
        endif 
      endif
  
      gMG1=mhf
      gMG2=mhf
      gMG3=mhf
      gAl=a0
      gAt=a0
      gAb=a0
      gMHu=m0
      gMHd=m0
      gMl2=m0
      gMl3=m0
      gMr2=m0
      gMr3=m0
      gMq2=m0  
      gMq3=m0
      gMu2=m0
      gMd2=m0
      gMu3=m0
      gMd3=m0

c  To save RGE input/output uncomment  line below
c      call delFiles(0)

      err=SUGRA(tb,gMG1,gMG2,gMG3,gAl,gAt,gAb,sgn,gMHu,gMHd,
     >gMl2,gMl3,gMr2,gMr3,gMq2,gMq3,gMu2,gMu3,gMd2,gMd3)

      IF(err.lt.0) THEN
         WRITE(*,*)' No RGE solution',err
         STOP
      ENDIF
      IF(err.lt.0)WRITE(*,*)
     >    'Warning: Non fatal problems in RGE solution'

C  To print list od variables uncomment   
C      CALL printVar(6)

      err=sortOddParticles(mess)
      if(err.ne.0) then
        write(*,*) 'Can t calculate ', mess
        STOP
      endif 

c      call printMasses(6,1)

C** Emin - energy cut           
      Emin=0.1     
C** outP: 0-photons, 1- positrons, 2 -antiprotons, 
C**     3-4-5 neutrunos with antineutrinos    
      outP=0
C** fi angle of sight     
      fi=0
 
      sigmaV=calcSpectrum(v,outP,tab,err)    
      M=lopmass()
      call spectrInfo(Emin/M,tab,Ntot,Etot) 
      write(buff,13) outName(outP+1),Ntot,Etot,sigmaV,mess,M  
13     format(A6,': ',
     > 'N=',1PE8.2,',<E/2M>=',1PE8.2,';vcs=',1PE8.2,
     >'cm^3/sec,M(',A3,')=',1PE8.2)

      err= spectrTable(tab,'tab',buff, Emin/M ,300)
    
      err= system('../CalcHEP_src/bin/tab_view < tab&') 
      
      write(*,fmt='(A26,1PE10.2 )') 'gamma flux[ph/cm^2/s/sr]= ',
     > sigmaV*Ntot*HaloFactor(fi, rhoQisotermic)/M/M  

100   STOP
      end
