#include "micromegas.h"
#include "micromegas_aux.h"


void printVar(FILE *f)
{
  int i;
  fprintf(f,"\n# Model parameters:\n");
  for(i=0;i<NVAR;i++) fprintf(f,"%-6.6s   %f\n", modelVar[i].name, modelVar[i].val);
}

double * varAddress(char *name)
{int i;
 for(i=0;i<NVAR;i++)if(!strcmp(name,modelVar[i].name))return &(modelVar[i].val);
 return NULL;
}

int assignVal(char * name, double val)
{
  double * a=varAddress(name);
  if(a)  {*a=val; return 0;} else return 1;
}


int findVal(char * name, double * val)
{
  double * va=varAddress(name); 
  if(va){*val=*va; return 0;} else  return 1;
  
}

void assignValW(char*name, double  val)
{ 
  if(assignVal(name,val)==1) printf(" %s not found\n",  name); 
}

double  findValW(char*name)
{
  double val;

  if(findVal(name,&val))
  {  printf(" name %s not found\n",name);
     return 0;
  } else return val;
}

int readVar(char *fname)
{
  double val;
  char name[80];
  int n;
  FILE * f=fopen(fname,"r");
  if(f==NULL) return -1;
  
  for(n=1;;n++)
  { if(fscanf(f,"%s",name)!=1) { n=0; break;}
    if(name[0]=='#') { fscanf(f,"%*[^\n]"); continue;}
    if(fscanf(f,"%lf",&val)!=1) break;
    fscanf(f,"%*[^\n]");
    { int err=assignVal(name,val);
      if(err==1) break;
    }
  }
  fclose(f);
  return n;                                         
}

int  assignval_(char * f_name, double * val, int len)
{  char buff[20];
   fName2c(f_name,buff,len);
   return assignVal(buff, *val);
}
                                                                                
int findval_(char*f_name, double*val, int len)
{
  char c_name[20];
  fName2c(f_name,c_name,len);
  return findVal(c_name,val);
}


void assignvalw_(char* f_name, double * val, int len)
{  char buff[20];
   fName2c(f_name,buff,len);
   assignValW(buff, *val);
}

double findvalw_(char*f_name, int len)  /*FORTRAN*/
{
  char c_name[20];
  fName2c(f_name,c_name,len);
  return findValW(c_name);
}

