#include"../sources/micromegas.h"
#include"lib/pmodel.h"
 
int main(int argc,char** argv)
{
  int    fast=1; 
  double Beps=1.E-4;
  double cut=0.01;
  double Omega,Xf;
  
  int err;  
  char mess[10];
  
  if(argc==1)
  { 
      printf(" Correct usage:  ./omg <file with parameters> \n");
      exit(1);
  }
                               

  err=readVar(argv[1]);
  if(err==-1)     {printf("Can not open the file\n"); exit(1);}
  else if(err>0)  { printf("Wrong file contents at line %d\n",err);exit(1);}
           

  err=sortOddParticles(mess);
  if(err) { printf("Can't calculate %s\n",mess); exit(1);}


  printMasses(stdout,1);


  printf("Dark Matter candidate is %s\n",mess);
  
  Omega=darkOmega(&Xf,fast,Beps);
  printf("Xf=%.2E Omega=%.2E  \n", Xf, Omega);
  printChannels(Xf,cut,Beps,1,stdout); 
}
